/*
Copyright © 2021 NAME HERE <EMAIL ADDRESS>

*/
package cmd

import (
	"time"

	"github.com/spf13/cobra"
	"isthisnagee.com/tools/diary/model"
)

// todayCmd represents the today command
var todayCmd = &cobra.Command{
	Use:   "today",
	Short: "List the diary entries added today, newest first",
	Long: `List all the entries added today, starting from the newest.
	To list all the entries:

	$ diary list
	`,
	Run: func(cmd *cobra.Command, args []string) {
		var created_after_ts *int64 = new(int64)
		var created_before_ts *int64 = new(int64)

		var now = time.Now()
		var startOfToday = time.Date(
			now.Year(),
			now.Month(),
			now.Day(),
			0,
			0,
			0,
			0,
			now.Location(),
		)
		*created_after_ts = startOfToday.Unix()
		var endOfToday = startOfToday.AddDate(0, 0, 1)
		*created_before_ts = endOfToday.Unix()

		results := App.GetDiaryEntries(model.GetDiaryEntriesQuery{
			CreatedBeforeTs: created_before_ts,
			CreatedAfterTs:  created_after_ts,
		})
		PrintEntries(results)

	},
}

func init() {
	listCmd.AddCommand(todayCmd)

	// Here you will define your flags and configuration settings.

	// Cobra supports Persistent Flags which will work for this command
	// and all subcommands, e.g.:
	// todayCmd.PersistentFlags().String("foo", "", "A help for foo")

	// Cobra supports local flags which will only run when this command
	// is called directly, e.g.:
	// todayCmd.Flags().BoolP("toggle", "t", false, "Help message for toggle")
}
